//
//  CantripSettingsModule.h
//  CantripPluginSDK
//
//  Created by James Callender on Sun May 05 2002.
//  Copyright (c) 2001 James Callender. All rights reserved.
//

/*!
	@header CantripSettingsModule.h
	@discussion Description forthcoming.
*/

#import <AppKit/AppKit.h>
#import "CantripPlugin.h"

@protocol WorldProtocol;

/*!
	@class CantripSettingsModule
	@abstract A class supporting a settings frame in the Settings Window
	@discussion  Description Forthcoming.
*/

@interface CantripSettingsModule : NSObject 
{

}

/*!
	@method settingsDisplayName
	@abstract Returns the display name for the module.
	@discussion  This name is placed under the icon in the settings panel.  
*/
- (NSString *)settingsDisplayName;

/*!
	@method settingsDisplayIcon
	@abstract Returns the image used for the icon in the settings panel.
	@discussion  Description Forthcoming.  
*/
- (NSImage *)settingsDisplayIcon;

/*!
	@method settingsView
	@abstract Returns the view instance to be displayed by the settings panel.
	@discussion Forthcoming.  
*/
- (NSView *)settingsView;

/*!
	@method size
	@abstract Returns the default size of the NSView.
	@discussion  These three methods size, minSize, and maxSize, return the default size, minimum size, and maximum size
	for the view in the settings panel, respectivly.  It is not necessary to override the
	minSize and maxSize methods (these will return (NSSize)size by default), 
	but you must override the size method in subclasses.
*/
- (NSSize)size;

/*!
	@method minSize
	@abstract Returns the maximum displayed size of the NSView.
	@discussion  See size.
*/
- (NSSize)minSize;

/*!
	@method maxSize
	@abstract Returns the minumum displayed size of the NSView.
	@discussion  See size.
*/
- (NSSize)maxSize;

/*!
	@method maxSize
	@abstract Called to update the settings view when a new world document has become active.
	@discussion  Description forthcoming.
	@param world  The active world.
*/
- (void)updateForWorld:(id <WorldProtocol>)world;

/*
	Optional methods to respond to revert: and apply: actions sent by the settings
	panel.  If your settings panel does not respond to these methods, the respective
	buttons will be disabled.
	
	- (void)revert:(id)sender;
	- (void)apply:(id)sender;
*/

@end
